#include "mbed.h"
#include "FXOS8700Q.h"
#include <string.h>
#include <string>
#include <math.h>
 //Write API Key Thingspeak : E4MFE93JOB6231Z8
 
 
//I2C lines for FXOS8700Q accelerometer/magnetometer
FXOS8700Q_acc acc( PTE25, PTE24, FXOS8700CQ_SLAVE_ADDR1);
FXOS8700Q_mag mag( PTE25, PTE24, FXOS8700CQ_SLAVE_ADDR1);
 
//Terminal enable 
Serial pc(USBTX, USBRX);
Serial myserial(PTC17,PTC16);
 
 
MotionSensorDataUnits mag_data;
MotionSensorDataUnits acc_data;
 

int main() 
{
    pc.baud(115200);
    myserial.baud(115200);
    float faX, faY, faZ;
    float fmX, fmY, fmZ;
    double last = 0;
    acc.enable();
    //printf("\r\n\nFXOS8700Q Who Am I= %X\r\n", acc.whoAmI());
    printf("Crash Detection System: ECE 595\n\n");
    char GPS_STATUS[100]={0};
    const char s[2]=",";
    char* tok;
    char parsed[5][15];
    int i = 0;
    double threshold=0;
    while (true) 
    {
        acc.getAxis(acc_data);
        acc.getX(&faX);
        acc.getY(&faY);
        
       threshold = sqrt(faX*faX + faY*faY);
        printf("FXOS8700Q ACC Threshold =%1.4f  \r\n", threshold );
        wait(0.2);
        
        if((threshold - last) <= -1.5 && threshold < 0.5)
        {            
            //initialize connections, get GPS
            printf("Crash detected\n\n");
            printf("Initializing GPRS...\n");
            myserial.printf("AT+CGATT=1\r");
            wait(1);
            myserial.printf("AT+SAPBR=3,1,\"CONTYPE\",\"GPRS\"\r");
            wait(1);
            myserial.printf("AT+SAPBR=3,1,\"APN\",\"att.mvno\"\r");
            wait(1);
            myserial.printf("AT+SAPBR=1,1\r");
            wait(1);
            printf("Getting GPS location...\n");
            myserial.printf("AT+CIPGSMLOC=1,1\r");
            wait(1);
            myserial.scanf("%*s %s",GPS_STATUS);
            tok=strtok(GPS_STATUS,s);
            while(tok!=NULL)
            {
                strcpy(parsed[i],tok);
                i++;
                //printf("%s\n",parsed[i-1]);
                tok=strtok(NULL,s);
            }
            printf("Long: %s\nLat: %s\nDate: %s\nTime: %s GMT\n",parsed[1],parsed[2],parsed[3],parsed[4]);    
            //send to thingspeak
           std::string lat(parsed[2]);
           std::string lon(parsed[1]);
           std::string tim(parsed[4]);
           std::string url = "AT+HTTPPARA=\"URL\",\"http://api.thingspeak.com/update?api_key=HYHZ2C5WKD2XBJVZ&field1=" + lat + "&field2=" + lon + "&field3=" + tim + "\"";
           printf("Connecting online...\n");
           myserial.printf("AT+SAPBR=0,1\r");
           wait(5);
           myserial.printf("AT+SAPBR=3,1,\"Contype\",\"GPRS\"\r");
           wait(3);
           myserial.printf("AT+SAPBR=3,1,\"APN\",\"CMNET\"\r");
           wait(3);
           myserial.printf("AT+SAPBR=1,1\r");
           wait(2);
           myserial.printf("AT+SAPBR=2,1\r");
           wait(3);
           printf("Initializing HTTP...\n");
           myserial.printf("AT+HTTPINIT\r");
           wait(1);
           myserial.printf("AT+HTTPPARA=\”CID\”,1\r");
           wait(1);
           myserial.printf("%s\r",url.c_str());
           wait(5);
           myserial.printf("AT+HTTPDATA=100,10000\r");
           wait(11);
           printf("Sending to server...\n");
           myserial.printf("AT+HTTPACTION=1\r");
           wait(10);
           myserial.printf("AT+HTTPTERM\r");
           wait(1);
           
            printf("Sending alert SMS message...\n");
           //SMS message
           myserial.printf("AT+CMGF=1\r");
           wait(1);
           myserial.printf("AT+CMGS=\"+13176651396\"\n");//12407556431//18125954508
           wait(1);
           myserial.printf("Crash Detected\n Click on this link to get the location of the crash : \n http://maps.google.com/?q=%s,%s \nDate: %s\nTime: %s GMT",parsed[2],parsed[1],parsed[3],parsed[4]);
           wait(1);
           myserial.printf("%c",(char)26);
           
           myserial.printf("AT+SAPBR=0,1");
           
           printf("Ending connections and resuming crash monitoring...\n\n");
        }
        last = threshold;
        wait(0.2);
        
        
        
    }
}